﻿package as3.comp{

	import flash.events.EventDispatcher;
	import flash.events.MouseEvent;
	import flash.text.AntiAliasType;
	import flash.text.TextFieldAutoSize;
	import flash.display.MovieClip;
	import fl.transitions.Tween;
	import fl.transitions.easing.Strong;

	public class button extends MovieClip {

		public var btnNum:Number;
		public var btnLink:String;
		public var btnType:Number;
		public var btnName:String;
		public var btnLinkType:Number;

		private var CBTNHEIGHT:Number;
		private var CBTNWIDTH:Number;

		private var CTXTTOP:Number;
		private var CTXTLEFT:Number;

		private var CDINAMIC:Number;
		private var CBTNDISABLE:Boolean;

		private var TMOTION:Number;//animation speed

		private var btnOverTween:Tween;
		private var btnDownTween:Tween;

		public function button():void {

			btn.model.btnOver.alpha=0;
			btn.model.btnDown.alpha=0;
		}

		public function startFirst():void {

			TMOTION=20;
			CBTNHEIGHT=25;
			CBTNWIDTH=150;

			CTXTTOP=2;
			CTXTLEFT=2;

			CDINAMIC=2;

			btnText.autoSize=TextFieldAutoSize.LEFT;
			//btnText.embedFonts = true;
			btnText.antiAliasType=AntiAliasType.ADVANCED;

			btnText.x=CTXTLEFT;
			btnText.y=CTXTTOP;

			CBTNDISABLE=false;
			setDisable(CBTNDISABLE, 0);
		}

		public function getText() {
			return btnText.htmlText;
		}
		public function setText(text1):void {
			btnText.htmlText=text1;
			btnText.y=CTXTTOP;
			btnText.x=CTXTLEFT;

			if (CDINAMIC==0) {
				btnText.width = CBTNWIDTH-(CTXTLEFT*2);
				setHeight(CBTNHEIGHT);
				setWidth(CBTNWIDTH);
			} else if (CDINAMIC == 1) {
				btnText.autoSize=TextFieldAutoSize.LEFT;
				setHeight(CBTNHEIGHT);
				setWidth(btnText.width + (CTXTLEFT*2) + 2);
			} else if (CDINAMIC == 2) {
				btnText.width = CBTNWIDTH - (CTXTLEFT*2);
				setWidth(CBTNWIDTH);
				btnText.wordWrap=true;
				btnText.autoSize=TextFieldAutoSize.LEFT;
				if ((btnText.height + (CTXTTOP)) > CBTNHEIGHT) {
					setHeight(btnText.height + (CTXTTOP*4));
				} else {
					setHeight(CBTNHEIGHT);
				}
			}
		}

		public function start():void {
			startFirst();
		}

		public function setHeight(fHeight):void {
			if (fHeight>6) {
				CBTNHEIGHT=fHeight;
			} else {
				CBTNHEIGHT=6;
			}
			btnSetHeight(CBTNHEIGHT);
		}

		public function setWidth(fWidth):void {
			if (fWidth>6) {
				CBTNWIDTH=fWidth;
			} else {
				CBTNWIDTH=6;
			}
			btnSetWidth(CBTNWIDTH);
		}
		public function setMotion(tValue:Number):void {
			TMOTION=tValue;
		}

		public function setDisable(myValue:Boolean, btnVar:Number):void {
			CBTNDISABLE=myValue;
			if (CBTNDISABLE) {
				space.removeEventListener(MouseEvent.MOUSE_OVER, overButton);
				btnOverTween=new Tween(btn.model.btnOver,"alpha",Strong.easeOut,0,1,TMOTION,false);
				if (btnVar==0) {
					btnDownTween=new Tween(btn.model.btnDown,"alpha",Strong.easeOut,0,1,TMOTION,false);
				} else {
					btnDownTween=new Tween(btn.model.btnDown,"alpha",Strong.easeOut,1,0,TMOTION,false);
				}
			} else {
				space.addEventListener(MouseEvent.MOUSE_OVER, overButton);
				btnOverTween=new Tween(btn.model.btnOver,"alpha",Strong.easeOut,1,0,TMOTION,false);
				btnDownTween=new Tween(btn.model.btnDown,"alpha",Strong.easeOut,1,0,TMOTION,false);
			}
		}
		public function setDinamic(myValue:Number):void {
			CDINAMIC=myValue;
		}
		public function getHeight() {
			return CBTNHEIGHT;
		}
		public function getWidth() {
			return CBTNWIDTH;
		}
		public function getMotion() {
			return TMOTION;
		}
		public function getDisable():Boolean {
			return CBTNDISABLE;
		}
		public function getDinamic():Number {
			return CDINAMIC;
		}
		// button functions

		public function overButton(event:MouseEvent):void {
			if (CBTNDISABLE==false) {
				space.addEventListener(MouseEvent.MOUSE_OUT, outButton);
				space.addEventListener(MouseEvent.MOUSE_DOWN, downButton);
				btnOverTween=new Tween(btn.model.btnOver,"alpha",Strong.easeOut,0,1,TMOTION,false);
			}
		}
		public function outButton(event:MouseEvent):void {
			if (CBTNDISABLE==false) {
				space.removeEventListener(MouseEvent.MOUSE_OUT, outButton);
				space.removeEventListener(MouseEvent.MOUSE_DOWN, downButton);
				btnOverTween=new Tween(btn.model.btnOver,"alpha",Strong.easeOut,1,0,TMOTION,false);
			}
		}
		public function downButton(event:MouseEvent):void {
			if (CBTNDISABLE==false) {
				btnDownTween=new Tween(btn.model.btnDown,"alpha",Strong.easeOut,0,1,TMOTION,false);
			}
			stage.addEventListener(MouseEvent.MOUSE_UP, upButton);
		}
		public function upButton(event:MouseEvent):void {
			if (CBTNDISABLE==false) {
				btnDownTween=new Tween(btn.model.btnDown,"alpha",Strong.easeOut,1,0,TMOTION,false);
			}
			stage.removeEventListener(MouseEvent.MOUSE_UP, upButton);
		}
		//skin function
		public function btnSetWidth(tWidth:Number):void {
			btn.model.btnOver.p1.width=tWidth;
			btn.model.btnDown.p1.width=tWidth;
			space.width=tWidth;
			btn.model.btnOn.p1.width=tWidth;

		}
		public function btnSetHeight(tHeight:Number):void {
			btn.model.btnOver.p1.height=tHeight;
			btn.model.btnDown.p1.height=tHeight;
			space.height=tHeight;
			btn.model.btnOn.p1.height=tHeight;
		}
	}
}