﻿package as3.comp{

	import flash.events.Event;
	import flash.events.MouseEvent;
	import fl.transitions.Tween;
	import fl.transitions.easing.Strong;
	import flash.geom.Rectangle;
	import flash.display.MovieClip;

	public class scrollbar extends MovieClip {

		private var movie:MovieClip;
		private var tMovieY:Number;

		private var THEIGHT:Number;//panel height
		private var TMAXHEIGHT:Number;//panel max height
		private var TWIDTH:Number;//panel width

		//scroll var
		private var TBCKWIDTH:Number;//scroll back width
		private var TBTNWIDTH:Number;//scroll button width
		private var TBTNHEIGHT:Number;//scroll button height

		//scroll space var
		private var TBTNTOP:Number;//scroll button top space
		private var TBTNBOTTOM:Number;//scroll button top space
		private var TBTNLEFT:Number;//scroll button left space
		private var TBCKLEFT:Number;//scroll back left space
		//scroll var
		private var TSCROLLMAX:Number;
		private var TSCROLLWHERE:Number;
		private var TSCROLLNUM:Number;
		private var TSCROLLMOVE:Number;
		//animation
		private var TMOTION:Number;
		//option
		private var TOPT:Boolean;

		private var x1Tween:Tween;
		private var mTween:Tween;
		private var sTween:Tween;
		private var pTween:Tween;
		private var mwTween:Tween;
		private var swTween:Tween;
		private var pwTween:Tween;
		private var byTween:Tween;
		private var x2Tween:Tween;
		private var x2aTween:Tween;
		private var x3Tween:Tween;
		private var x4Tween:Tween;
		private var x5Tween:Tween;
		private var x6Tween:Tween;
		private var bTween:Tween;
		private var a1Tween:Tween;
		private var btnOverTween:Tween;
		private var btnDownTween:Tween;

		public function scrollbar():void {
			bck.btn.addEventListener(MouseEvent.MOUSE_DOWN, dragButton);
			bck.addEventListener(MouseEvent.MOUSE_DOWN, bckButton);
			bck.btn.space.addEventListener(MouseEvent.MOUSE_OVER, overButton);
			bck.btn.space.addEventListener(MouseEvent.MOUSE_OUT, outButton);
			addEventListener(MouseEvent.MOUSE_WHEEL, wheelButton);
			bck.btn.model.btnOver.alpha=0;
			bck.btn.model.btnDown.alpha=0;
		}

		public function startFirst():void {
			TBCKWIDTH=16;//scroll back width

			TBTNTOP=2;//scroll button top space
			TBTNBOTTOM=2;
			TBTNLEFT=2;//scroll button left space
			TBCKLEFT=0;//scroll back left space
		}

		public function start():void {//OKEY

			startFirst();

			THEIGHT=0;//panel height
			TMAXHEIGHT=0;//panel max height
			TWIDTH=0;//panel width

			TBTNWIDTH = TBCKWIDTH - (TBTNLEFT*2);//scroll button width
			TBTNHEIGHT=0;

			TSCROLLMAX=0;//scroll un maksimum gidebileceği konum
			TSCROLLNUM=0;//
			TSCROLLMOVE=1;//scrollun hareket aralığı
			TSCROLLWHERE=0;//scrollun bulunduğu konum

			TMOTION=1;
			movie=new MovieClip();
			tMovieY=0;

		}

		public function addContentMovie(myContent:MovieClip):void {//Tween names
			movie=myContent;
			if (Number(tMovie.numChildren)>0) {
				tMovie.removeChildAt(0);
			}
			tMovie.addChildAt(movie, 0);
			TMAXHEIGHT=movie.height;
			tMovie.mask=tMask;
			x3Tween = new Tween(tMovie, "y", Strong.easeOut, (TMAXHEIGHT-THEIGHT) * -1, tMovieY, TMOTION, false);
			a1Tween=new Tween(tMovie,"alpha",Strong.easeOut,0,1,TMOTION,false);
			bck.btn.y = 0;
		}
		public function setHeight(fHeight):void {
			if (fHeight>50) {
				THEIGHT=fHeight;
			} else {
				THEIGHT=50;
			}
		}
		public function setWidth(fWidth):void {//OK
			if (fWidth>50) {
				TWIDTH=fWidth;
			} else {
				TWIDTH=50;
			}
		}
		public function setScrollWidth(sWidth:Number):void {
			TBCKWIDTH=sWidth;
			TBTNWIDTH = TBCKWIDTH - (TBTNLEFT*2);
		}
		public function setMotion(tValue:Number):void {//OK
			TMOTION=tValue;
		}
		public function setScrollMove(scrollMove:Number):void {//OK
			TSCROLLMOVE=scrollMove;
		}
		public function setScrollWhere(myValue):void {
			if (myValue<=0) {
				byTween=new Tween(bck.btn,"y",Strong.easeOut,bck.btn.y,TBTNTOP,TMOTION,false);
				TSCROLLWHERE=0;
			} else if (myValue>=TSCROLLMAX) {
				byTween=new Tween(bck.btn,"y",Strong.easeOut,bck.btn.y,TSCROLLMAX+TBTNTOP,TMOTION,false);
				TSCROLLWHERE=TSCROLLMAX;
			} else {
				byTween=new Tween(bck.btn,"y",Strong.easeOut,bck.btn.y,myValue+TBTNTOP,TMOTION,false);
				TSCROLLWHERE=myValue;
			}
			scrollRefresh();
		}
		public function setAllWidth(myValue):void {
			if (bck.visible) {
				setWidth(myValue - TBCKLEFT - TBCKWIDTH);
			} else {
				setWidth(myValue);
			}
		}
		public function setOptBtn(myOpt:Boolean):void {
			TOPT=myOpt;
		}
		public function setContentWhere(myValue):void {
			if (myValue<=(TMAXHEIGHT-THEIGHT)) {
				setScrollWhere(int(myValue / TSCROLLNUM));
			}
		}

		public function getHeight() {
			return THEIGHT;
		}
		public function getWidth() {
			return TWIDTH;
		}
		public function getScrollWidth() {
			return TBCKWIDTH;
		}
		public function getMotion() {
			return TMOTION;
		}
		public function getScrollMove() {
			return TSCROLLMOVE;
		}
		public function getScrollWhere() {
			return TSCROLLWHERE;
		}
		public function getScrollMax() {
			return TSCROLLMAX;
		}
		public function getAllWidth() {
			var rVal:Number;
			if (bck.visible) {
				rVal=TWIDTH+TBCKLEFT+TBCKWIDTH;
			} else {
				rVal=TWIDTH;
			}
			return rVal;
		}
		public function getOptBtn():Boolean {
			return TOPT;
		}

		public function scrollRefresh():void {
			tMovieY=int(TSCROLLWHERE*TSCROLLNUM);
			var dim=tMovieY%TSCROLLMOVE;
			tMovieY=tMovieY-dim;
			x4Tween=new Tween(tMovie,"y",Strong.easeOut,tMovie.y,tMovieY*-1,TMOTION,false);
		}
		public function refresh():void {
			mTween=new Tween(tMask,"height",Strong.easeOut,tMask.height,THEIGHT,TMOTION,false);
			sTween=new Tween(tStroke,"height",Strong.easeOut,tStroke.height,THEIGHT,TMOTION,false);
			pTween=new Tween(tPanel,"height",Strong.easeOut,tPanel.height,THEIGHT,TMOTION,false);
			mwTween=new Tween(tMask,"width",Strong.easeOut,tPanel.width,TWIDTH,TMOTION,false);
			swTween=new Tween(tStroke,"width",Strong.easeOut,tPanel.width,TWIDTH,TMOTION,false);
			pwTween=new Tween(tPanel,"width",Strong.easeOut,tPanel.width,TWIDTH,TMOTION,false);

			bckSetWidth(TBCKWIDTH);

			bck.btn.x=TBTNLEFT;
			bckSetHeight(THEIGHT);
			TBTNHEIGHT = int((THEIGHT*THEIGHT)/TMAXHEIGHT);
			if (TBTNHEIGHT<TBTNWIDTH) {
				TBTNHEIGHT=TBTNWIDTH;
			}
			btnSetHeight(TBTNHEIGHT);
			btnSetWidth(TBTNWIDTH);

			TSCROLLMAX = THEIGHT-(TBTNTOP+TBTNBOTTOM)-TBTNHEIGHT;
			TSCROLLNUM = (TMAXHEIGHT - THEIGHT) / TSCROLLMAX;
			//TMAXHEIGHT = movie.height;

			setScrollWhere(getScrollWhere());
			x2Tween=new Tween(bck,"x",Strong.easeOut,bck.x,TWIDTH+TBCKLEFT,TMOTION,false);

			if (TMAXHEIGHT>THEIGHT) {
				bck.btn.visible=true;
			} else {
				bck.btn.visible=false;
			}
		}
		public function scrollShow(myMovie:MovieClip, myHeight:Number, myWidth:Number, myMotion:Number, myScrollMove:Number):void {
			start();
			setHeight(myHeight);
			setWidth(myWidth);
			setMotion(myMotion);
			setScrollMove(myScrollMove);
			addContentMovie(myMovie);
			refresh();
		}

		// button functions
		private function frameButton(event:Event):void {
			setScrollWhere(bck.btn.y - TBTNTOP);
			//scrollRefresh();
		}
		private function wheelButton(event:MouseEvent):void {
			var myint:Number = new Number();
			if (bck.btn.visible) {
				myint = getScrollWhere() - (Number(event.delta)*5);
				setScrollWhere(myint);
			}
		}
		private function dragButton(event:MouseEvent):void {
			var rect:Rectangle;
			rect=new Rectangle(TBTNLEFT,
			   TBTNTOP,
			   0,
			   TSCROLLMAX);
			bck.btn.startDrag(false,rect);
			btnDownTween=new Tween(bck.btn.model.btnDown,"alpha",Strong.easeOut,0,1,TMOTION,false);
			stage.addEventListener(MouseEvent.MOUSE_UP, stopButton);
			stage.addEventListener(MouseEvent.MOUSE_MOVE, frameButton);
		}
		private function stopButton(event:MouseEvent):void {
			bck.btn.stopDrag();
			btnDownTween=new Tween(bck.btn.model.btnDown,"alpha",Strong.easeOut,1,0,TMOTION,false);
			stage.removeEventListener(MouseEvent.MOUSE_MOVE, frameButton);
			stage.removeEventListener(MouseEvent.MOUSE_UP, stopButton);
		}
		private function overButton(event:MouseEvent):void {
			btnOverTween=new Tween(bck.btn.model.btnOver,"alpha",Strong.easeOut,0,1,TMOTION,false);
		}
		private function outButton(event:MouseEvent):void {
			btnOverTween=new Tween(bck.btn.model.btnOver,"alpha",Strong.easeOut,1,0,TMOTION,false);
		}
		private function bckButton(event:MouseEvent):void {
			var myint:Number = new Number();
			var myvalue:Number = new Number();
			if (mouseY<bck.btn.y) {
				myvalue=1;
			} else if (mouseY > bck.btn.y + bck.btn.height) {
				myvalue=-1;
			}
			if (myvalue!=0) {
				myvalue=myvalue*Number(bck.btn.height);
				myint=getScrollWhere()-myvalue;
				setScrollWhere(myint);
			}
		}

		//skin function
		public function bckSetWidth(tWidth:Number):void {
			bck.model.p1.width=tWidth;
			bck.space.width=tWidth;
		}
		public function bckSetHeight(tHeight:Number):void {
			bck.space.height=tHeight;
			x5Tween=new Tween(bck.model.p1,"height",Strong.easeOut,bck.model.p1.height,tHeight,TMOTION,false);
		}
		public function btnSetWidth(tWidth:Number):void {
			if (tWidth<=Number(bck.btn.opt.width+4)||TOPT==false) {
				bck.btn.opt.visible=false;
			} else {
				bck.btn.opt.visible=true;
			}

			bck.btn.model.btnOn.p1.width=tWidth;
			bck.btn.model.btnOver.p1.width=tWidth;
			bck.btn.model.btnDown.p1.width=tWidth;
			bck.btn.space.width=tWidth;
			bck.btn.opt.x = (tWidth - bck.btn.opt.width) / 2;

		}
		public function btnSetHeight(tHeight:Number):void {
			if (tHeight <= (bck.btn.opt.height + 4) || TOPT == false) {
				bck.btn.opt.visible=false;
			} else {
				bck.btn.opt.visible=true;
			}

			bck.btn.model.btnOver.p1.height=tHeight;
			bck.btn.model.btnDown.p1.height=tHeight;
			bck.btn.space.height=tHeight;

			x6Tween=new Tween(bck.btn.model.btnOn.p1,"height",Strong.easeOut,bck.btn.model.btnOn.p1.height,tHeight,TMOTION,false);
			bTween = new Tween(bck.btn.opt, "y", Strong.easeOut, bck.btn.opt.y, int((tHeight - bck.btn.opt.height) / 2), TMOTION, false);
		}
	}
}