﻿package as3.comp{

	import flash.events.Event;
	import flash.events.TimerEvent;
	import flash.utils.Timer;
	import fl.transitions.Tween;
	import fl.transitions.easing.Strong;
	import flash.display.MovieClip;

	public class slider extends MovieClip {

		public var openWindows:String;

		public var imageWidth:Number;
		public var imageHeight:Number;
		public var imageInt:Number;

		public var imagePage:Number;
		public var totalPage:Number;

		public var imageTween:Tween;
		public var buttonTween:Tween;

		public var timer:Timer;

		public function slider():void {
			
			buttons.btn1.start();
			buttons.btn1.setDinamic(2); //0, 1, 2:multiline and html code
			buttons.btn1.setWidth(25);
			buttons.btn1.setText(<![CDATA[<img src="img/icon/left.png" hspace="0" vspace="2" />]]>);
			
			buttons.btn2.start();
			buttons.btn2.setDinamic(2); //0, 1, 2:multiline and html code
			buttons.btn2.setWidth(25);
			buttons.btn2.setText(<![CDATA[<img src="img/icon/right.png" hspace="0" vspace="2" />]]>);
			
			this.addEventListener("mouseOver", imageSliderF);
			this.addEventListener("mouseDown", imageSliderF);
			this.addEventListener("mouseOut", imageSliderF);
		}

		private function gonextf(e:TimerEvent):void {
			slideImage("next");
		}

		public function start() {
			//standart width, height

			setWidth(670);
			setHeight(300);

			buttons.visible=false;

			imagePage=1;
			imageInt=0;

			timer=new Timer(12000);

			timer.addEventListener(TimerEvent.TIMER, gonextf);
			timer.start();

			openWindows="_self";//_self: same windows, _blank: new windows

		}
		public function setWidth(mw:Number) {
			imageWidth=mw;
			stroke.width=imageWidth;
			space.width=imageWidth;
			buttons.x = (imageWidth - buttons.width) - 20;
			//buttons.x = int((imageWidth - buttons.width) / 2);
		}
		public function setHeight(mh:Number) {
			imageHeight=mh;
			stroke.height=imageHeight;
			space.height=imageHeight;
			buttons.y=imageHeight;
		}

		public function slideImage(mym:String) {
			if (mym=="next") {
				if (imagePage!=totalPage) {
					buttons.btn1.setDisable(false, 0);
					imagePage++;
				} else {
					imagePage=1;
				}
			}
			if (mym=="prev") {
				if (imagePage!=1) {
					buttons.btn2.setDisable(false, 0);
					imagePage--;
				} else {
					imagePage=totalPage;
				}
			}
			imageTween = new Tween(images, "x", Strong.easeOut, images.x, ((imagePage-1) * imageWidth)*-1 , 9, false);
			buttons.btnS.text=imagePage+"/"+totalPage;
		}

		public function addNew(var1:String, var2:String, var3:String) {

			if (imageInt>0) {
				buttons.visible=true;
				timer.addEventListener(TimerEvent.TIMER, gonextf);
				timer.start();
			}

			var myImage:imageSliderImage = new imageSliderImage();
			images.addChild(myImage);
			myImage.loadImage(var1, var2, var3);

			myImage.x=imageWidth*imageInt;
			myImage.y=0;

			imageInt++;
			totalPage=imageInt;
			buttons.btnS.text=imagePage+"/"+totalPage;
		}

		private function imageSliderF(evt:Event):void {
			if (evt.type=="mouseDown") {
				if (evt.target.parent.name=="btn2") {
					slideImage("next");
				}
				if (evt.target.parent.name=="btn1") {
					slideImage("prev");
				}
			} else if (evt.type == "mouseOver") {
				timer.stop();
				buttonTween=new Tween(buttons,"y",Strong.easeOut,buttons.y,imageHeight-buttons.height,9,false);
			} else if (evt.type == "mouseOut") {
				timer.start();
				buttonTween=new Tween(buttons,"y",Strong.easeOut,buttons.y,imageHeight,9,false);
			}
		}

	}
}