﻿package as3{

	import flash.events.Event;
	import flash.display.MovieClip;
	import flash.events.EventDispatcher;
	import flash.events.MouseEvent;
	import fl.transitions.Tween;
	import fl.transitions.easing.Strong;
	import flash.net.URLRequest;
	import flash.net.navigateToURL;
	import flash.display.StageAlign;
	import flash.display.StageScaleMode;
	import as3.xmlLoad;

	public class site extends MovieClip {

		public var i:uint; //menu component
		public var homepage:String; //scrollbar component

		public var listXML:xmlLoad=new xmlLoad("xml/images.xml"); //imageslider component
		public var myMenuXML:xmlLoad=new xmlLoad("xml/menu.xml"); //menu component
		public var myCopyrightXML:xmlLoad=new xmlLoad("xml/copyright.xml"); //copyright

		public var myContent:_content = new _content(); //scrollbar component
		public var skrolMotion:Number=7; //scrollbar component

		public var subMenuT1:Tween; //menu component
		public var subMenuT2:Tween; //menu component
		public var siteAni:Tween; //site

		public function site():void {

			stage.scaleMode=StageScaleMode.NO_SCALE;
			stage.align=StageAlign.TOP_LEFT;

			actionf();
			logof();
			imagesliderf();
			menuf();
			copyrightf();

		}

		//LOADING ACTION

		public function actionf() {
			
			siteTip.start();//start component
			siteTip.followMouse(true);//mouse following

			this.addEventListener(Event.ENTER_FRAME, loadingf);

		}

		function loadingf(event:Event):void {
			siteTip.show((myLogo.myText.text));
			if (int(myLogo.myText.text)>=100) {
				this.removeEventListener(Event.ENTER_FRAME, loadingf);
				siteAni=new Tween(open_mc,"x",Strong.easeOut,open_mc.x,open_mc.width*-1,9,false);
				siteTip.hide();
			}

		}

		//LOGO ACTION /////////////////////////////////////////////////////////////
		public function logof() {
			myLogo.loadImage("logo.png");
		}

		//IMAGE SLIDER ACTION /////////////////////////////////////////////////////////////
		public function imagesliderf() {
			myImageSlider.start();//component
			myImageSlider.setWidth(980);
			myImageSlider.setHeight(250);//Dont change after add new.
			myImageSlider.openWindows="_self";//_self: same windows, _blank: new windows

			//var i:uint;

			//var listXML:xmlLoad=new xmlLoad("xml/images.xml");
			listXML.addEventListener("loaded", xmlLoaded);
		}
		function xmlLoaded(event:Event):void {
			event.target.removeEventListener("loaded", xmlLoaded);
			for (i=0; i<=event.target.xml.image.length()-1; i++) {
				myImageSlider.addNew(event.target.xml.setting.@path+event.target.xml.image[i].@file,event.target.xml.image[i].@link,event.target.xml.image[i].info);// image path, url, info
			}
		}

		//SCROLLBAR ACTION /////////////////////////////////////////////////////////////

		public function scrollbarf() {
			//var myContent:_content = new _content();

			myContent.start();//set your content width
			myContent.contentWidth=980;//set your content path
			myContent.loadContent(homepage);//html code

			//var skrolMotion:Number=7;

			myScrollbar.start();// start component
			myScrollbar.setMotion(skrolMotion);
			myScrollbar.addContentMovie(myContent);//add your content
			myScrollbar.setOptBtn(true);
			myScrollbar.setHeight(Number(stage.stageHeight) - 410);
			myScrollbar.setAllWidth(990);
			myScrollbar.setScrollMove(1);
			myScrollbar.refresh();

			myScrollbar.x=5;
			myScrollbar.y=380;
			myBText.y=Number(stage.stageHeight)-22;
			siteAlt.y=myBText.y-3;

			stage.addEventListener(Event.RESIZE, stageChange);
		}

		public function stageChange(event:Event):void {
			myBText.y=Number(stage.stageHeight)- 22;
			siteAlt.y=myBText.y-3;
			myScrollbar.setHeight(Number(stage.stageHeight) - 410);
			myScrollbar.refresh();
		}



		//MENU ACTION /////////////////////////////////////////////////////////////

		public function menuf() {
			myMenuXML.addEventListener("loaded", myMenuXMLLoaded);
			myMenu.addEventListener("mouseDown", myMenuF);//when pressed to menu
			mySubMenu.addEventListener("mouseDown", mySubMenuF);
		}

		function myMenuXMLLoaded(event:Event):void {

			event.target.removeEventListener("loaded", myMenuXMLLoaded);

			myMenuRefresh(0,0);//show menu and select button(id:0)
			mySubMenuRefresh(0,0);//show sub menu and no selected button
			
			scrollbarf(); // homepage variable

		}

		function myMenuRefresh(myMenuNo:Number, selectedId:Number) {

			myMenu.start();//start menu component
			myMenu.selectedId=selectedId;//set selected button
			myMenu.menuNo=myMenuNo;
			switch (myMenuNo) {
				case 0 :
					if(myMenuXML.xml.menu[0].@link != undefined) {
						homepage = myMenuXML.xml.menu[0].@link;
					}else if(myMenuXML.xml.menu[0].submenu.menu[0].@link != undefined) {
						homepage = myMenuXML.xml.menu[0].submenu.menu[0].@link;
					}
					for (i=0; i<=myMenuXML.xml.menu.length()-1; i++) {
						myMenu.addNew(myMenuXML.xml.menu[i].@name);//Add new name to menu
					}

					break;
				default :
					trace(".");
			}
		}


		function myMenuF(evt:Event):void {
			if (evt.type=="mouseDown") {
				if (evt.target.parent.btnNum!=null) {
					if (myMenu.myOldButon!=evt.target.parent.btnNum) {
						myMenu.changeBtn(evt.target.parent.btnNum);//change pressed button
						if (myMenuXML.xml.menu[evt.target.parent.btnNum].@link!=undefined) {
							changePage(myMenuXML.xml.menu[evt.target.parent.btnNum].@link);
						}
						//set submenu x
						subMenuT1=new Tween(mySubMenu,"x",Strong.easeOut,mySubMenu.x,int(myMenu.x+evt.target.parent.x),7,false);
						subMenuT2=new Tween(mySubMenu,"alpha",Strong.easeIn,0,1,5,false);
						//mySubMenu.x = myMenu.x + evt.target.parent.x; 
						mySubMenuRefresh(evt.target.parent.btnNum,-1);//show submenu
					}
				}
			}
		}

		function mySubMenuRefresh(mySubMenuNo:Number, selectedId:Number) {

			mySubMenu.start();
			mySubMenu.selectBtn(2);
			mySubMenu.selectedId=selectedId;
			mySubMenu.mySubMenuNo=mySubMenuNo;
			for (i=0; i<=myMenuXML.xml.menu[mySubMenuNo].submenu.menu.length()-1; i++) {
				mySubMenu.addNew(myMenuXML.xml.menu[mySubMenuNo].submenu.menu[i].@name);//Add new name to menu
			}
		}



		function mySubMenuF(evt:Event):void {
			if (evt.type=="mouseDown") {
				if (evt.target.parent.btnNum!=null) {
					if (mySubMenu.myOldButon!=evt.target.parent.btnNum) {
						mySubMenu.changeBtn(evt.target.parent.btnNum);//change pressed button
						if (myMenuXML.xml.menu[mySubMenu.mySubMenuNo].submenu.menu[evt.target.parent.btnNum].@link!=undefined) {
							changePage(myMenuXML.xml.menu[mySubMenu.mySubMenuNo].submenu.menu[evt.target.parent.btnNum].@link);
						}
					}
				}
			}
		}

		function changePage(fileName:String) {
			//trace(fileName.substr(0,7));
			if (fileName.substr(0,7)=="http://") {
				var url:String=fileName;
				var request:URLRequest=new URLRequest(url);
				navigateToURL(request, "_self");
			} else {
				myContent = new _content();
				myContent.start();
				myContent.contentWidth=980;
				myScrollbar.addContentMovie(myContent);//add your content
				myScrollbar.refresh();
				myContent.loadContent(fileName);
			}
		}

		//COPYRIGHT ACTION /////////////////////////////////////////////////////////////

		public function copyrightf() {
			myCopyrightXML.addEventListener("loaded", myCopyrightXMLLoaded);
		}
		function myCopyrightXMLLoaded(event:Event):void {
			event.target.removeEventListener("loaded", myCopyrightXMLLoaded);
			myBText.htmlText=event.target.xml.copyright[0];
		}

	}
}